/*
 Representación de un número en decimal con caracteres ASCII.

      Se almacena la representación como cadena, poniendo 0's 
      en las posiciones más significativas si es necesario.

*/
      .data
num:  .hword      457
res:  .space      5

      .text
main: ldr      r4, =res      @ dirección del resultado
      mov      r3, #5        @ contador de caracteres
      ldr      r0, =num
      ldr      r0, [r0]      @ numero a convertir

otro:                        @ pasamos (lo que queda d)el número
      bl       div10         @ dividimos por 10
                             @ el resto en r1 será el nuevo dígito.
      add      r1, #'0'      @ pasamos a ascii
      sub      r3, r3, #1
      strb     r1, [r4, r3]  @ almacenamos en su posición

      cmp      r0, #0        @ ¿hemos terminado?
      beq      escero

      cmp      r3, #0        @ ¿el último dígito era el de orden 5?
      beq      fin

escero:      
      mov      r0, #'0'      @ rellenamos con ceros, es decir,

otrop:      
      sub      r3, r3, #1    @ ponemos 0's en los caracteres que 
      strb     r0, [r4, r3]  @ faltan
      cmp      r3, #0
      bne      otrop
      
fin:  wfi

/*
 Subprograma para dividir por 10.

      Entrada: en r0 una palabra con el dividendo
      Salida:  en r0 el cociente, y en r1 el resto

      En este ejemplo, realizamos la división por restas sucesivas
      (algoritmo de Euclides de la división).
*/
div10:      
      mov      r2, #0         @ init cociente a 0 (r2)

bucle:      
      cmp      r0, #10        @ ¿divisor menor que 10?
      blt      fins           @ si lo es, acabamos

      add      r2, r2, #1     @ sumamos 1 al cociente
      sub      r0, r0, #10    @ restamos 10 del dividendo
      b        bucle                  

fins:     
      mov      r1, r0         @ almacenamos el resto
      mov      r0, r2         @ y el cociente
      mov      pc, lr
      .end
