
     .data
cad: .byte  0xa1, 'H', 'o', 'l', 'a', ' ', 'p', 'e', 'q', 'u', 'e'
     .byte  0xf1, 'o', ' ', 'm', 'u', 'n', 'd', 'o', ' ', 'm'
     .byte  0xed, 'o', '!', 0x00
res: .space 36

   .text
main:
   ldr   r4, =cad     @ r4: dir. de la cadena de partida
   ldr   r5, =res     @ r5: dir. del resultado
buc:   
   ldrb  r0, [r4]     @ r0: cargamos un carácter   
   cmp   r0, #0       @ vemos si fin de cadena
   beq   acab

   bl    btoutf8      @ convertimos el carácter utilizando 
   cmp   r0, #0x80    @ el subprograma; vemos si es de 2 bytes
   blt   solo1

   strb  r0, [r5, #1] @ almacenamos el byte menos signific. (de segundo)
   lsr   r0, r0, #8   @ preparamos el byte más significativo (0xCX)
   strb  r0, [r5, #0] @ para almacenar el 0xCX en su sitio
   add   r5, r5, #2   @ incrementamos el puntero
   b     otro

solo1:   
   strb  r0, [r5]     @ almacenamos tal cual
   add   r5, r5, #1
otro:   
   add   r4, r4, #1
   b     buc

acab:    wfi


/*

 btoutf8: subprograma para convertir caracteres en el rango  
 0x00 a 0xff en caracteres UTF8 de 1 o 2 bytes.

   entrada: r0, byte menos significativo, carácter de entrada
   salida:  r0, conversión de 1 o 2 bytes. resto a cero.
*/
btoutf8:
   mov   r1,#ff
   and   r0,  r0, r1 @ nos quedamos con el byte menos significativo
   cmp   r0, #0x80
   blt   yaconv      @ carácter de 1 byte. No nay que convertirlo.

   ldr   r2, =0xC000 @ máscara para el byte más significativo
   ldr   r3, =0xff00 @ máscara para borrar el byte más sign.

   lsl   r1, r0, #2  @ byte de r1: el byte más significativo
   orr   r1, r1, r2  @ del resultado
   and   r1, r1, r3

   mov   r2,#0x3f    @ cambiamos los dos bits más signif.
   and   r0, r0, r2  @ de r0 por 0b10
   mov   r2,#0x80
   orr   r0, r0, r2

   orr   r0, r0, r1  @ y montamos todo en r0

yaconv:   
   mov   pc,lr
   .end