/*
 Comparamos dos cadenas terminadas en 0

*/
      .data
cad1: .asciz "¡Hola Mundo!"
cad2: .asciz "¡Hola Mundo!"
res:  .space 1

      .text
main: ldr     r5, =cad1      @ direcciones de las cadenas
      ldr     r6, =cad2
      mov     r7, #0xff      @ suponemos que son distintas

      mov     r0, r5
      bl      tamc           @ calculamos el tamaño de la primera
      mov     r4, r0

      mov     r0,r6
      bl      tamc           @ y el de la segunda
      mov     r3, r0

      cmp     r3, r4
      bne     fin            @ si los tamaños son diferentes
                             @ las cadenas no pueden ser iguales
      mov     r0, r5
      mov     r1, r6
      bl      eqc            @ vemos si son iguales
      mov     r7, r0         @ recuperamos el resultado

fin:  ldr     r1, =res
      strb    r7, [r1]       @ almacenamos el resultado
      wfi

@ 
@ subrutina de cálculo del tamaño de una cadena de caracteres 
@ terminada en 0
@
@      entrada: en r0: dir. de comienzo de la cadena (1 word)
@      salida:  en r0: tamaño (1 word)
@
tamc: 
      mov    r2, #0     @ contador a cero
buctc:      
      ldrb   r1, [r0]   @ cargamos byte de primera cadena
      cmp    r1, #0     @ vemos si hemos terminado
      beq    tcd                  
      add    r2, r2, #1 @ incrementamos contador
      add    r0, r0, #1 @ incrementamos el puntero
      b      buctc

tcd:  mov    r0, r2     @ almacenamos el resultado
      mov    pc,lr      @ volvemos
@
@ subrutina que determina si dos cadenas terminadas en 0 de la misma 
@ longitud son iguales
@
@      entrada: r0, r1: direcciones de comienzo de las cadenas
@      salida:  r0: 0x00000000 = son iguales, 0x000000ff son 
@               diferentes.
@
eqc:  ldrb   r2, [r0]      @ cargamos un carácter
      cmp    r2, #0        @ si llegamos al final
      beq    fieqc         @ es que son iguales
      ldrb   r3, [r1]      @ cargamos uno de la otra cadena
      cmp    r2, r3        @ los comparamos
      bne    disteqc       @ si no, cadenas distintas
      add    r0, r0, #1    @ actualizamos punteros
      add    r1, r1, #1
      b      eqc           @ otro carácter

fieqc:      
      mov    r0, #0x00     @ son iguales
      mov    pc,lr

disteqc:                   @ son diferentes
      mov    r0, #0xff
      mov    pc, lr
      .end
